#!/usr/bin/env python

"""
   Demonstration of GPIO access under Python for Bifferboard
   (www.bifferos.com).

"""

import os, fcntl, struct, time, sys


class GPIO:
  "Class to encapsulate communication with the driver"

  def __init__(self):
    self.fd = os.open("/dev/gpio_proxy", os.O_RDWR)

  def gpio_set_value(self, pin, val):
    if val:
      fcntl.ioctl(self.fd, 1, pin)
    else:
      fcntl.ioctl(self.fd, 2, pin)

  def gpio_direction_output(self, pin, val):
    if val:
      fcntl.ioctl(self.fd, 3, pin)
    else:
      fcntl.ioctl(self.fd, 4, pin)

  def status(self):
    fcntl.ioctl(self.fd, 5, 0)

  def gpio_direction_input(self, pin):
    fcntl.ioctl(self.fd, 6, pin)

  def gpio_get_value(self, pin):
    return fcntl.ioctl(self.fd, 7, pin)



def flash():
  g.gpio_direction_output(5,1)

  # Print the status of the GPIO register
  g.status()

  # Flash the red LED on and off three times.
  print "Look at the LED flashing"
  for i in xrange(0,10):
    g.gpio_set_value(5,1)
    time.sleep(0.5)
    g.gpio_set_value(5,0)
    time.sleep(0.5)
		
		
def button():
  # Sample the button status
  # You must set the value of an input pin to '1' before using it as input
  g.gpio_set_value(4,1)
  g.gpio_direction_input(4)
  print "Push the button"
  for i in xrange(0,15):
    button = g.gpio_get_value(4)
    print "Button is now", button
    time.sleep(0.5)
    
def Usage():
  print "biff-gpio.py - Bifferboard GPIO demonstration script"
  print 
  print "usage: biff-gpio.py <operation>"
  print
  print "<operation> can be:"
  print "'flash': Flash the red LED on and off"
  print "'button': Sample the button state"
  print
  


if __name__ == "__main__":

  if sys.argv[1:]:
    cmd = sys.argv[1]
    if cmd == "flash":
      flash()
    elif cmd == "button":
      button()
    else:
      Usage()
  else:
    Usage()



